#ifndef OSSPSFC_H
#define OSSPSFC_H

#include <stdlib.h>
#include "wintypes.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <assert.h>

typedef char TCHAR;
#define MAX_PATH 256

#ifdef __cplusplus 
  extern "C" {
#endif

#define MQVAL(x) val.x

extern int g_MultiThreadSupport;

typedef struct timeb TIMESTRUCT_OS;
typedef int EVENTOBJ_OS;

void GetTime_OS(TIMESTRUCT_OS* pTS);
double GetElapsedTime_OS(TIMESTRUCT_OS* pStartTime, TIMESTRUCT_OS* pEndTime);
void CreateEvents_OS(void);
void CloseEvents_OS(void);
void Sleep_OS(unsigned long ulMilliSeconds);
void SetEvent_OS(EVENTOBJ_OS g_hSync1);
void ResetEvent_OS(EVENTOBJ_OS g_hSync1);
void WaitForEvent_OS(EVENTOBJ_OS hEvent);
LONG InterlockedDecrement_OS(LONG* pDecVar);
LONG InterlockedExchange_OS(LONG* pExchgVar, LONG NewVal);
void StartThreads_OS(void);

#ifdef __cplusplus 
  }
#endif

#endif
